=== src/c_interface/Makefile ===
##################################################
# About this Makefile
#
# This Makefile depends on Makefile.opts
##################################################

MODULE = c_interface

SRC = c_interface.cpp

LIBRARY=libc_interface.a

include ../../Makefile.local
