=== src/context/Makefile ===
##################################################
# About this Makefile
#
# This Makefile depends on Makefile.opts
##################################################

MODULE = context

SRC = context.cpp cdflags.cpp

LIBRARY=libcontext.a

include ../../Makefile.local
