=== src/expr/Makefile ===
##################################################
# About this Makefile
#
# This Makefile depends on Makefile.opts
##################################################

MODULE = expr

SRC =   expr.cpp \
  expr_manager.cpp \
  expr_stream.cpp \
  expr_value.cpp \
  expr_op.cpp

LIBRARY=libexpr.a

include ../../Makefile.local
