=== debian/changelog ===
cvc3 (2.4.1-5.1ubuntu1) zesty; urgency=medium

  * Apply patch from debian to fix FTBFS with gcc 6.

 -- Bhavani Shankar <bhavi@ubuntu.com>  Sun, 22 Jan 2017 09:04:35 +0530

cvc3 (2.4.1-5ubuntu1) wily; urgency=medium

  * Rename library packages for g++5 ABI transition.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 03 Aug 2015 22:33:48 +0000

cvc3 (2.4.1-5) unstable; urgency=low

  * New maintainer. (Closes: #757192)
  * Fix clean target, resolving ppc64el FTBFS. (Closes: #756524)
  * Update standards version.
  * Fix dep5 copyright.
  * Remove Vcs-git and Vcs-browser (not available for CVC3).
  * Now lintian clean (with some overrides).

 -- Morgan Deters <mdeters@morgandeters.com>  Sat, 27 Sep 2014 12:21:27 -0400

cvc3 (2.4.1-4) unstable; urgency=low

  * Transfer package repo to Git.
  * Fix syntax error in debian/copyright.
  * Keep 50cvc3-el.el after remove. (Closes: #684351)
  * Use ln -sf when linking cvc3-el emacsen files. (Closes: #684026)
  * Remove build dep on gcj-native-helper. (Closes: #678183)

 -- Christopher L. Conway <cconway@cs.nyu.edu>  Sun, 12 Aug 2012 17:15:51 -0400

cvc3 (2.4.1-3) unstable; urgency=low

  * Create new package libcvc3-dev to replace libcvc3-5-dev and
    libcvc3-2-dev (Closes: #662198)
  * Add Replaces/Conflicts to libcvc3-5-jni for libcvc3-2-jni
    (Closes: #662200)
  * Leave .el files in site-lisp directory when installing cvc3-el
    to enable source lookup (Closes: #665319)
  * Remove cvc-mode autoload from site-start.d on cvc3-el removal
    (Closes: #668688)
  * Bring cvc3-el.emacsen-startup in line with Debian policy
    (Closes: #668685)

 -- Christopher L. Conway <cconway@cs.nyu.edu>  Mon, 16 Apr 2012 22:23:39 -0400

cvc3 (2.4.1-2) unstable; urgency=low

  * Upgrading to standards version 3.9.3
  * Fixing lintian errors
  * Fixing upstream tarball

 -- Christopher L. Conway <cconway@cs.nyu.edu>  Sat, 03 Mar 2012 18:00:13 -0500

cvc3 (2.4.1-1) unstable; urgency=low

  * New upstream release (Closes: #660244)
  * Updating to standards version 3.9.2
  * Switching to dpkg-source 3.0 (quilt) format
  * Changing default-jdk-builddep build dependency to default-jdk
  * Re-enabling libcvc3-jni on kfreebsd-amd64 (Closes: #576335)

 -- Christopher L. Conway <cconway@cs.nyu.edu>  Sat, 25 Feb 2012 13:54:15 -0500

cvc3 (2.2-13.1) unstable; urgency=low

   * NMU.  Change dependencies libgmp3-dev --> libgmp-dev.

 -- Steve M. Robbins <smr@debian.org>  Wed, 16 Mar 2011 21:43:31 -0500

cvc3 (2.2-13) unstable; urgency=low

  * Prevent Java tests from running on kfreebsd-amd64

 -- Christopher L. Conway <cconway@cs.nyu.edu>  Thu, 08 Apr 2010 13:46:21 -0400

cvc3 (2.2-12) unstable; urgency=low

  * Adding patch for MiniSat unsigned char bug (Closes: #575002)
  * Removing kfreebsd-amd64 from Architectures for libcvc3-2-jni (Workaround for
    #576335)

 -- Christopher L. Conway <cconway@cs.nyu.edu>  Tue, 06 Apr 2010 15:02:53 -0400

cvc3 (2.2-11) unstable; urgency=low

  * Patch: detect path to ldconfig for install

 -- Christopher L. Conway <cconway@cs.nyu.edu>  Tue, 16 Mar 2010 17:21:15 -0400

cvc3 (2.2-10) unstable; urgency=low

  * Upgrading to Debian Policy 3.8.4
  * Fixing problem with library path in 'make check'

 -- Christopher L. Conway <cconway@cs.nyu.edu>  Fri, 12 Mar 2010 17:48:43 -0500

cvc3 (2.2-9) unstable; urgency=low

  * Fixing bug in build environment for 'make check'

 -- Christopher L. Conway <cconway@cs.nyu.edu>  Tue, 26 Jan 2010 17:42:06 -0500

cvc3 (2.2-8) unstable; urgency=low

  * Adding regress0 as check target
  * Adding patch to create pkgconfig file

 -- Christopher L. Conway <cconway@cs.nyu.edu>  Tue, 26 Jan 2010 13:15:39 -0500

cvc3 (2.2-7) unstable; urgency=low

  * Adding cvc-mode to auto-mode-alist in cvc3-el

 -- Christopher L. Conway <cconway@cs.nyu.edu>  Wed, 06 Jan 2010 18:09:30 -0500

cvc3 (2.2-6) unstable; urgency=low

  * Moving cvc3 from Depends to Recommends for cvc3-el

 -- Christopher L. Conway <cconway@cs.nyu.edu>  Wed, 06 Jan 2010 17:45:43 -0500

cvc3 (2.2-5) unstable; urgency=low

  * Changing section for libcvc3-2 to 'libs'

 -- Christopher L. Conway <cconway@cs.nyu.edu>  Sun, 03 Jan 2010 13:37:27 -0500

cvc3 (2.2-4) unstable; urgency=low

  * Fixing lintian warnings for deps in emacs package and shlibs in JNI package

 -- Christopher L. Conway <cconway@cs.nyu.edu>  Thu, 31 Dec 2009 17:03:18 -0500

cvc3 (2.2-3) unstable; urgency=low

  * Fixing lintian warnings

 -- Christopher L. Conway <cconway@cs.nyu.edu>  Wed, 30 Dec 2009 18:08:59 -0500

cvc3 (2.2-2) unstable; urgency=low

  * Adding cvc3-el package

 -- Christopher L. Conway <cconway@cs.nyu.edu>  Thu, 10 Dec 2009 12:48:15 -0500

cvc3 (2.2-1) unstable; urgency=low

  * Initial release (Closes: bug#559245)

 -- Christopher L. Conway <cconway@cs.nyu.edu>  Mon, 07 Dec 2009 18:19:56 -0500
