=== debian/watch ===
# Compulsory line, this is a version 3 file
version=3

opts=pgpsigurlmangle=s/$/.asc/ \
    http://www.cs.nyu.edu/acsys/cvc3/releases/current/cvc3-([\d\.]+)\.tar\.gz
